----------------------------------------------------------------
------------ Naruto pack skill by Joni And Friends -------------
----------------------------------------------------------------
----------------------------------------------------------------

function totable(t,match)
	local cmd = {}
	if not match then match = "[^%s]+" end
	for word in string.gmatch(t, match) do
		table.insert(cmd, word)
	end 
	return cmd 
end

----===== Table's =====----
jaf={}
jaf.image={}
jaf.skills={}
jaf.skillget={}
jaf.posx={}
jaf.posy={}
jaf.skill={}

----===== Hooks =====----
addhook("attack","jaf.attack")
addhook("join","jaf.join")
addhook("ms100","jaf.ms100")
addhook("spawn","jaf.spawn")
addhook("menu","jaf.menu")

----===== Functions =====----
function jaf.detectplayer(x,y,what,ignore)
	if ( what ~= "playeron" ) then
		return tile_(x,y,what);
	end
		for i = 1, 32 do
			if ( player(i, "exists") ) then
				local px = player(i, "x")-12
				local py = player(i, "y")-12
				if ( x >= px and y >= py and x <= px + 24 and y <= py+24 and i ~= ignore and player(i, "health") > 0 ) then
					return {i,true}
				end
			end
		end
		return {0,false}
end

function jaf.blockdetect(id)
           local rot,x,y = (player(id,"rot")-90)*math.pi/180,player(id,"x"),player(id,"y")
           last_rot=player(id,"rot")
                dist=0
		x = x + 16*math.cos(rot)
		y = y + 16*math.sin(rot)
	        local scale = 32;
                while ( not (tile(math.floor(x/32),math.floor(y/32),"wall")) and (objectat(math.floor(x/32),math.floor(y/32),30)==0) and (not jaf.detectplayer(x, y, "playeron",id)[2]) ) do
                        dist=dist+1
			x = x+math.cos(rot)
			y = y+math.sin(rot)
                 end
                 return {target=jaf.detectplayer(x, y, "playeron",id)[1],x=x,y=y,rot=last_rot,dis=dist}
end

function jaf.radiuscheck(id,x,y,radiusx,radiusy)
	if not (radiusx and radiusy) then radiusx, radiusy = 320, 240 end
	local x1, y1, x2, y2 = x-radiusx, y-radiusy, x+radiusx, y+radiusy
		if player(id, 'x') >= x1 and player(id, 'x') <= x2 and player(id, 'y') >= y1 and player(id, 'y') <= y2 then
                    return true
		end
end

function jaf.freeimage(id)
         if jaf.image[id]~=nil then
                freeimage(jaf.image[id])
                jaf.image[id]=nil
         end
end

function jaf.ms100()
        for _,id in pairs(player(0,"tableliving")) do
                  if jaf.skillget[id][4]==true then
                       dmg=3
                     for _,g in pairs(player(0,"tableliving")) do
                       tgt=jaf.radiuscheck(g,jaf.posx[id],jaf.posy[id],(4*32+16),(4*32+16))
                       if tgt==true and player(g,"health")>0 and dmg>=player(g,"health") then
                              parse("customkill "..id.." \"Rasenshuriken\" "..g)
                       elseif tgt==true and player(g,"health")>0 then
                              parse("sethealth "..g.." "..player(g,"health")-dmg)
                              parse("speedmod "..g.." -100")
                       end
                     end
                   end
        end
end
                               
                       

function jaf.getskill(id,skill_no)
        local x,y,rot,di=jaf.blockdetect(id).x,jaf.blockdetect(id).y,jaf.blockdetect(id).rot,jaf.blockdetect(id).dis/1000
        targetID=jaf.blockdetect(id).target
        if jaf.skill[id] and jaf.skill[id]<=1 then --- kunai bomb skill
                  -- msg(player(id,"name").." using kunai bomb skill")
                  jaf.freeimage(id)
                  jaf.skillget[id][1]=true
                  jaf.image[id]=image("gfx/JAF/NarutoPack/kunaibomb.png",1,0,1)
                  imagepos(jaf.image[id],player(id,"x"),player(id,"y"),rot)
                  tween_move(jaf.image[id],(di*1000),x,y)
                  timer((di*1000),"jaf.timer1",""..id.."")
                  function jaf.timer1(id)
                  id=tonumber(id)
                  parse("explosion "..x.." "..y.." \"100\" \"100\" "..id)
                  jaf.freeimage(id)
                  jaf.skills[id]=0
                  jaf.skillget[id][1]=false
                  end
        elseif jaf.skill[id] and jaf.skill[id]==2 then  --- shuriken shot
                  -- msg(player(id,"name").." using Shuriken shot skill")
                  jaf.freeimage(id)
                  jaf.skillget[id][2]=true
                  dmg_shuriken=math.random(10,20)
                  jaf.image[id]=image("gfx/JAF/NarutoPack/shuriken.png",1,0,1)
                  imagepos(jaf.image[id],player(id,"x"),player(id,"y"),rot)
                  tween_rotateconstantly(jaf.image[id],55)
                  tween_move(jaf.image[id],(di*900),x,y)
                  timer((di*900),"jaf.timer2",""..id.." "..targetID.."")
                  function jaf.timer2(idd)
                  idd=totable(idd)
                  id=tonumber(idd[1])
                  pl=tonumber(idd[2])
                  if pl>0 and player(pl,"health")>0 and dmg_shuriken>player(pl,"health") then
                      parse("customkill "..id.." \"Shuriken\" "..pl)
                  elseif pl>0 and player(pl,"health")>0 then
                      parse("sethealth "..pl.." "..player(pl,"health")-dmg_shuriken)
                  end
                  jaf.freeimage(id)
                  jaf.skills[id]=0
                  jaf.skillget[id][2]=false
                  end
        elseif jaf.skill[id] and jaf.skill[id]==3 then --- fire ball skill
                  -- msg(player(id,"name").." using Fire ball skill")
                  jaf.freeimage(id)
                  jaf.skillget[id][3]=true
                  dmg_fireball=math.random(50,80)
                  jaf.image[id]=image("gfx/JAF/NarutoPack/fire_ball.png",1,0,1)
                  imagepos(jaf.image[id],player(id,"x"),player(id,"y"),rot)
                  imagescale(jaf.image[id],0,0)
                  tween_scale(jaf.image[id],(di*1500),1.5,1.8)
                  tween_move(jaf.image[id],(di*1500),x,y)
                  timer((di*1500),"jaf.timer3",""..id.." "..targetID.."")
                  function jaf.timer3(idd)
                  idd=totable(idd)
                  id=tonumber(idd[1])
                  pl=tonumber(idd[2])
                 parse("effect \"fire\" "..x.." "..y.." 100 100 255 000 000")
                  if pl>0 and player(pl,"health")>0 and dmg_fireball>player(pl,"health") then
                      parse("customkill "..id.." \"Fire Ball\" "..pl)
                  elseif pl>0 and player(pl,"health")>0 then
                      parse("sethealth "..pl.." "..player(pl,"health")-dmg_fireball)
                  end
                  jaf.freeimage(id)
                  jaf.image[id]=image("gfx/JAF/NarutoPack/fire_cycle.png",1,0,1)
                  imagepos(jaf.image[id],x,y,rot)
                  tween_scale(jaf.image[id],300,5,5)
                  tween_rotateconstantly(jaf.image[id],20)
                  timer(400,"jaf.timer3_2",""..id.."")
                  function jaf.timer3_2(id)
                  id=tonumber(id)
                  parse("explosion "..x.." "..y.." \"200\" \"200\" "..id)
                  jaf.freeimage(id)
                  jaf.skills[id]=0
                  jaf.skillget[id][3]=false
                  end
                  end
        elseif jaf.skill[id] and jaf.skill[id]==4 then -- rasenshuriken skill
                  -- msg(player(id,"name").." using Rasenshuriken skill")
                  jaf.freeimage(id)
                  jaf.skillget[id][4]=false
                  jaf.image[id]=image("gfx/JAF/NarutoPack/rasenshuriken.png",1,0,1)
                  imagepos(jaf.image[id],player(id,"x"),player(id,"y"),rot)
                  tween_rotateconstantly(jaf.image[id],-50)
                  jaf.posx[id]=x
                  jaf.posy[id]=y
                  tween_move(jaf.image[id],(di*1600),x,y)
                  timer((di*1600),"jaf.timer4",""..id.."")
                  function jaf.timer4(id)
                  id=tonumber(id)
                  jaf.skillget[id][4]=true
                  tween_rotateconstantly(jaf.image[id],-70)
                  tween_scale(jaf.image[id],300,5,5)
                  timer(4000,"jaf.timer4_2",""..id.."")
                  function jaf.timer4_2(id)
                  id=tonumber(id)
                  jaf.freeimage(id)
                  for _,g in pairs(player(0,"tableliving")) do
                       tgt=jaf.radiuscheck(g,jaf.posx[id],jaf.posy[id],(4*32+16),(4*32+16))
                       if tgt==true and player(g,"speedmod")<1 then
                              parse("speedmod "..g.." 0")
                       end
                  end
                  jaf.skills[id]=0
                  jaf.skillget[id][4]=false
                  parse("effect \"colorsmoke\" "..x.." "..y.." 100 128 255 255 255")
                  parse("effect \"colorsmoke\" "..x.." "..y.." 100 128 30 144 255")
                  parse("effect \"colorsmoke\" "..x.." "..y.." 100 128 255 255 255")
                  end
                  end
        end
end

function jaf.attack(id)
        random_skill=math.random(1,4)
        wpn=player(id,"weapontype")
      if jaf.skills[id]==0 and wpn==50 then
        jaf.skills[id]=1
        jaf.getskill(id,random_skill)
     end
end

function jaf.join(id)
         jaf.image[id]=nil
         jaf.skills[id]=0
         jaf.skillget[id]={}
         jaf.posx[id]=0
         jaf.posy[id]=0
         jaf.skill[id]=0
end

function jaf.spawn(id)
         menu(id,"Choose skill,Kunai bomb,Shuriken,Fire ball,Rasenshuriken")
end

function jaf.menu(id,title,button)
         if title=="Choose skill" then
            if button>0 then
               jaf.skill[id]=button
            end
         end
end